var _a;
import "@nativescript/macos-node-api";
import { Event } from "../../dom/dom-utils.js";
export class ButtonClickEvent extends Event {
    constructor(state, eventDict) {
        super("click", eventDict);
        this.state = state;
    }
}
export class NativeButton extends NSButton {
    static initWithOwner(owner) {
        const button = _a.new();
        button._owner = owner;
        return button;
    }
    clicked(_id) {
        const owner = this._owner?.deref();
        if (owner) {
            owner.dispatchEvent(new ButtonClickEvent(this.state === NSOnState));
        }
    }
    setTitle(title) {
        this._title = title;
        this.updateButtonTitleStyle();
    }
    setTitleColor(color) {
        this._color = color;
        this.updateButtonTitleStyle();
    }
    updateButtonTitleStyle() {
        if (!this._attributedTitle) {
            this._attributedTitle = NSMutableAttributedString.alloc().init();
        }
        this._attributedTitle.mutableString.setString(this._title || "");
        this._attributedTitle.setAttributesRange({
            [NSForegroundColorAttributeName]: this._color,
        }, { location: 0, length: this._title?.length || 0 });
        this.attributedTitle = this._attributedTitle;
    }
}
_a = NativeButton;
NativeButton.ObjCExposedMethods = {
    clicked: { returns: interop.types.void, params: [interop.types.id] },
};
(() => {
    NativeClass(_a);
})();
//# sourceMappingURL=native-button.js.map